#ifndef _VEC
#define _VEC

typedef struct _vec3 {
    float x;
    float y;
    float z;
} vec3;

vec3 vec3_new(float x, float y, float z);
vec3 vec3_splat(float f);
vec3 vec3_add(vec3 a, vec3 b);
vec3 vec3_sub(vec3 a, vec3 b);
float vec3_dot(vec3 a, vec3 b);
vec3 vec3_mult(vec3 a, float s);

// Some opengl extensions to support these vectors
void glVertexVec(vec3 v);
void glColorVec(vec3 v);

#endif
